<?php

/* Copyright (C) 2014		 Support       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

global $langs, $conf, $html, $db, $hookmanager, $action, $dictionary, $user;


$action      = GETPOST('action', 'alpha');
$confirm     = GETPOST('confirm', 'alpha');
$id          = GETPOST('id', 'int');
$rowid       = GETPOST('rowid', 'int');
$prevrowid   = GETPOST('prevrowid', 'int');
$module      = GETPOST('module', 'alpha');
$familyFilter = GETPOST('family', 'alpha');
$name        = GETPOST('name', 'alpha');
// Load variable for pagination
$limit = GETPOST('limit', 'int') ? GETPOST('limit', 'int') : $conf->liste_limit;
$sortfield = GETPOST('sortfield', 'alpha');
$sortorder = GETPOST('sortorder', 'alpha');
$page = GETPOST('page', 'int');
$order_by = array();
if (empty($sortfield)) {
	$orders = explode(',', $dictionary->listSort);
	foreach ($orders as $order) {
		$tmp = explode(' ', trim($order));
		$order_by[$tmp[0]] = $tmp[1];
	}
	} else {
	$order_by[$sortfield] = $sortorder;
}
// If $page is not defined, or '' or -1
if (empty($page) || $page == -1) {
	$page = 0;
}
$offset = $limit * $page;
$pageprev = $page - 1;
$pagenext = $page + 1;

// Init hook
$contextpage = isset($dictionary) ? 'dictionary' : 'dictionarylist';
$hookmanager->initHooks(array($contextpage));

// Params
$param = 'page=dictionaries&module=' . urlencode($dictionary->module) . '&name=' . urlencode($dictionary->name);
if (!empty($sortfield)) $param .= '&sortfield=' . urlencode($sortfield);
if (!empty($sortorder)) $param .= '&sortorder=' . urlencode($sortorder);
if (!empty($page)) $param .= '&page=' . urlencode($page);
if ($limit > 0 && $limit != $conf->liste_limit) $param .= '&limit=' . $limit;

$search_active = 1;
$search_filters = array();

if (isset($dictionary) && $dictionary->enabled) {
// Filter active
$search_active = GETPOST('search_' . $dictionary->active_field, 'int');
if ($search_active === '') $search_active = 1;

// Params
$search_filters = $dictionary->getSearchFieldsValueFromForm();
foreach ($search_filters as $fieldName => $filter) {
	$param .= '&search_' . $fieldName . '=' . urlencode($filter);
}
if ($search_active != 1) $param .= '&search_' . $dictionary->active_field . '=' . urlencode($search_active);
}


	$canCreate = $user->admin;
$canRead = $user->admin;
$canUpdate = $user->admin;
$canDelete = $user->admin;
$canDisable = $user->admin;

		
		
$form = new Form($db);

if (!isset($dictionary) || !$dictionary->enabled)
{
    print $langs->trans("DictionaryDesc");
    print " ".$langs->trans("OnlyActiveElementsAreShown")."<br>\n";
}

print "<br>\n";

/*
 * Show a dictionary
 */
 
if (isset($dictionary) && $dictionary->enabled) {
    //------------------------------------------------------------------------------------------------------------------
    // Generate the add form
    //------------------------------------------------------------------------------------------------------------------
    if ($dictionary->lineCanBeAdded && $canCreate) {
        print '<form action="' . $_SERVER['PHP_SELF'] . '?' . $param . '" method="POST">';
        print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
        print '<input type="hidden" name="action" value="add">';

        print '<div class="div-table-responsive-no-min">';
        print '<table class="noborder" width="100%">';

        // Line for title
        $has_required_fields = false;
        print '<tr class="liste_titre">';
        foreach ($dictionary->fields as $fieldName => $field) {
            if (!$field['is_not_addable']) {
                $label = $langs->trans($field['label']);
                $moreClasses = !empty($field['td_title']['moreClasses']) ? ' class="' . $field['td_title']['moreClasses'] . '"' : '';
                $moreAttributes = !empty($field['td_title']['moreAttributes']) ? ' ' . $field['td_title']['moreAttributes'] : '';
                $align = !empty($field['td_title']['align']) ? $field['td_title']['align'] : $dictionary->getAlignFlagForField($fieldName);

                print '<td align="' . $align . '"' . $moreClasses . $moreAttributes . '>';
                if (!empty($field['is_require'])) {
                    $has_required_fields = true;
                    print '<span class="fieldrequired">';
                }
                if (!empty($field['help'])) {
                    if (preg_match('/^http(s*):/i', $field['help'])) print '<a href="' . $field['help'] . '" target="_blank">' . $label . ' ' . img_help(1, $label) . '</a>';
                    else print $form->textwithpicto($label, $langs->trans($field['help']));
                } else print $label;
                if (!empty($field['is_require'])) {
                    print ' *</span>';
                }
                print '</td>';
            }
        }
        print '<td style="min-width: 26px;"></td>';
        print '</tr>';

        $dictionary_line = $dictionary->getNewDictionaryLine();
        $dictionary_line->fields = $dictionary->getFieldsValueFromForm('add_');

        // Line to enter new values
        print '<tr class="oddeven nodrag nodrop nohover">';
        foreach ($dictionary->fields as $fieldName => $field) {
            if (!$field['is_not_addable']) {
                $moreClasses = !empty($field['td_intput']['moreClasses']) ? ' class="' . $field['td_intput']['moreClasses'] . '"' : '';
                $moreAttributes = !empty($field['td_intput']['moreAttributes']) ? ' ' . $field['td_intput']['moreAttributes'] : '';
                $align = !empty($field['td_intput']['align']) ? $field['td_intput']['align'] : $dictionary->getAlignFlagForField($fieldName);

                print '<td align="' . $align . '"' . $moreClasses . $moreAttributes . '>';
                print $dictionary_line->showInputField($fieldName, null, 'add_');
                print '</td>';
            }
        }

        // Button
        print '<td align="center">';
        print '<input type="submit" class="button" name="actionadd" value="' . $langs->trans("Add") . '">';
        print '</td>';
        print "</tr>";

        print '</table>';
        print '</div>';

        print '</form>';

        if ($has_required_fields) print '<i>* ' . $langs->trans("AdvancedTicketFieldRequired") . '</i><br>';

        print '<br>';
    }

    //------------------------------------------------------------------------------------------------------------------
    // Show list of values
    //------------------------------------------------------------------------------------------------------------------

    // Confirmation de la suppression de la ligne
    if ($action == 'delete') {
        print $form->formconfirm(dol_buildpath('/framework/admin/index.php',2). '?' . $param . '&rowid=' . $rowid . '&prevrowid=' . $prevrowid, $langs->trans('DeleteLine'), $langs->trans('ConfirmDeleteLine'), 'confirm_delete', '', 0, 1);
    }

    if ($dictionary->fetch_lines($search_active, $search_filters, $order_by, $offset, $limit + 1) > 0) {
        $nbtotalofrecords = '';
        if (empty($conf->global->MAIN_DISABLE_FULL_SCANLIST)) {
            $nbtotalofrecords = $dictionary->fetch_lines($search_active, $search_filters, array(), 0, 0, true);
        }
        $num = count($dictionary->lines);

        print '<form action="' .dol_buildpath('/framework/admin/index.php',2). '?" method="POST">';
        print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
        print '<input type="hidden" name="action" value="confirm_edit">';
        print '<input type="hidden" name="page" value="dictionaries">';
        print '<input type="hidden" name="module" value="'.dol_escape_htmltag($dictionary->module).'">';
        print '<input type="hidden" name="name" value="'.dol_escape_htmltag($dictionary->name).'">';
        if (!empty($sortfield)) print '<input type="hidden" name="sortfield" value="'.dol_escape_htmltag($sortfield).'">';
        if (!empty($sortorder)) print '<input type="hidden" name="sortorder" value="'.dol_escape_htmltag($sortorder).'">';
        if (!empty($page)) print '<input type="hidden" name="page" value="'.dol_escape_htmltag($page).'">';
        if ($limit > 0 && $limit != $conf->liste_limit) print '<input type="hidden" name="limit" value="'.dol_escape_htmltag($limit).'">';
        if ($search_active != 1) print '<input type="hidden" name="search_'.$dictionary->active_field.'" value="'.dol_escape_htmltag($search_active).'">';

        print_barre_liste('', $page, dol_buildpath('/framework/admin/index.php',2), $param, $sortfield, $sortorder, '', $num, $nbtotalofrecords, '', 0, '', '', $limit);

        $moreforfilter = '';
        // More filters from hook
        $parameters = array();
        $reshook = $hookmanager->executeHooks('printFieldPreListTitle', $parameters, $dictionary, $action);
        if (empty($reshook)) $moreforfilter .= $hookmanager->resPrint;
        else $moreforfilter = $hookmanager->resPrint;

        if (!empty($moreforfilter)) {
            print '<div class="liste_titre liste_titre_bydiv centpercent">';
            print $moreforfilter;
            print '</div>';
        }

        print '<div class="div-table-responsive">';
        print '<table class="noborder" width="100%">';

        // Title line with search boxes
        print '<tr class="liste_titre">';
        foreach ($dictionary->fields as $fieldName => $field) {
            if (!$field['is_not_show']) {
                $moreClasses = !empty($field['td_search']['moreClasses']) ? ' class="' . $field['td_search']['moreClasses'] . '"' : '';
                $moreAttributes = !empty($field['td_search']['moreAttributes']) ? ' ' . $field['td_search']['moreAttributes'] : '';
                $align = !empty($field['td_search']['align']) ? $field['td_search']['align'] : $dictionary->getAlignFlagForField($fieldName);

                print '<td align="' . $align . '"' . $moreClasses . $moreAttributes . '>';
                if (!$field['is_not_searchable']) {
                    print $dictionary->showInputSearchField($fieldName);
                }
                print '</td>';
            }
        }
        // Fields from hook
        $parameters = array();
        $reshook = $hookmanager->executeHooks('printFieldListOption', $parameters, $dictionary, $action);
        print $hookmanager->resPrint;
        print '<td align="center">';
        print $form->selectyesno('search_' . $dictionary->active_field, $search_active, 1, false, 1);
        print '</td>';
        print '<td class="liste_titre" align="right">';
        print $form->showFilterButtons();
        print '</td>';
        print '</tr>';

        // Title of lines
        print '<tr class="liste_titre">';
        foreach ($dictionary->fields as $fieldName => $field) {
            if (!$field['is_not_show']) {
                $moreClasses = !empty($field['td_title']['moreClasses']) ? ' class="' . $field['td_title']['moreClasses'] . '"' : '';
                $moreAttributes = !empty($field['td_title']['moreAttributes']) ? ' ' . $field['td_title']['moreAttributes'] : '';
                $align = !empty($field['td_title']['align']) ? $field['td_title']['align'] : $dictionary->getAlignFlagForField($fieldName);
                $moreAttributes .= ' align="' . $align . '"';

                print getTitleFieldOfList($langs->trans($field['label']), 0, dol_buildpath('/framework/admin/index.php',2), ($field['is_not_sortable'] ? '' : $fieldName), '', $param, $moreAttributes, $sortfield, $sortorder, $moreClasses);
            }
        }
        // Fields from hook
        $parameters = array();
        $reshook = $hookmanager->executeHooks('printFieldListTitle', $parameters, $dictionary, $action);
        print $hookmanager->resPrint;
        print getTitleFieldOfList($langs->trans("Status"), 0, dol_buildpath('/framework/admin/index.php',2), $dictionary->active_field, '', $param, 'width="10%" align="center"', $sortfield, $sortorder);
        print getTitleFieldOfList('', 0, "", "", "", "", 'width="32px"');
        print '</tr>';

        // Lines with values
        $var = false;
        $last_rowid = 0;
        foreach ($dictionary->lines as $line) {
//         print_r($line); 
//         exit; 
        
            $var = !$var;
            if ($action == 'edit' && $dictionary->lineCanBeUpdated && $canUpdate && $line->id == $rowid) {
                $dictionary_line = clone $line;
                $fieldsValue = $dictionary->getFieldsValueFromForm('edit_');

                print '<input type="hidden" name="rowid" value="' . $line->id . '">';

                // Line to enter new values
                print '<tr class="oddeven nodrag nodrop nohover">';
                foreach ($dictionary->fields as $fieldName => $field) {
                    if (!$field['is_not_show']) {
                        $moreClasses = !empty($field['td_intput']['moreClasses']) ? ' class="' . $field['td_intput']['moreClasses'] . '"' : '';
                        $moreAttributes = !empty($field['td_intput']['moreAttributes']) ? ' ' . $field['td_intput']['moreAttributes'] : '';
                        $align = !empty($field['td_intput']['align']) ? $field['td_intput']['align'] : $dictionary->getAlignFlagForField($fieldName);

                        print '<td align="' . $align . '"' . $moreClasses . $moreAttributes . '>';
                        if (!$field['is_not_addable']) {
                            if (isset($fieldsValue[$fieldName])) $dictionary_line->fields[$fieldName] = $fieldsValue[$fieldName];
                            print $dictionary_line->showInputField($fieldName, null, 'edit_');
                        } else {
                            print $line->showOutputField($fieldName);
                        }
                        print '</td>';
                    }
                }

                // Fields from hook
                $parameters = array();
                $reshook = $hookmanager->executeHooks('printFieldListValue', $parameters, $line, $action);
                print $hookmanager->resPrint;

                // Button
                print '<td colspan="2" align="center">';
                print '<input type="submit" class="button" name="actionedit" value="' . $langs->trans("Edit") . '">';
                print '<input type="submit" class="button" name="actioncancel" value="' . $langs->trans("Cancel") . '">';
                print '</td>';
                print "</tr>";
            } else {
                // Output line
                print '<tr class="' . $bc[$var] . '" id="rowid-' . $line->id . '">';
                foreach ($dictionary->fields as $fieldName => $field) {
                    if (!$field['is_not_show']) {
                        $moreClasses = !empty($field['td_output']['moreClasses']) ? ' class="' . $field['td_output']['moreClasses'] . '"' : '';
                        $moreAttributes = !empty($field['td_output']['moreAttributes']) ? ' ' . $field['td_output']['moreAttributes'] : '';
                        $align = !empty($field['td_output']['align']) ? $field['td_output']['align'] : $dictionary->getAlignFlagForField($fieldName);

                        print '<td align="' . $align . '"' . $moreClasses . $moreAttributes . '>';
                        print $line->showOutputField($fieldName);
                        print '</td>';
                    }
                }

                // Fields from hook
                $parameters = array();
                $reshook = $hookmanager->executeHooks('printFieldListValue', $parameters, $line, $action);
                print $hookmanager->resPrint;

                // Active
                print '<td align="center" class="nowrap">';
                $isLineCanBeDisabled = $dictionary->isLineCanBeDisabled($line);
                if ($isLineCanBeDisabled === null) {
                    print $langs->trans("AlwaysActive");
                } elseif ($isLineCanBeDisabled === true && $canDisable) {
                    print '<a href="' . dol_buildpath('/framework/admin/index.php',2). '?page=dictionaries&' . $param . '&action=activate_' . ($line->active ? 'off' : 'on') . '&rowid=' . $line->id . '#rowid-' . $line->id . '">' .
                        img_picto($langs->trans($line->active ? 'Activated' : 'Disabled'), $line->active ? 'switch_on' : 'switch_off') . '</a>';
                } elseif (is_string($isLineCanBeDisabled)) {
                    print $langs->trans($isLineCanBeDisabled);
                } else {
                    print img_picto($langs->trans($line->active ? 'Activated' : 'Disabled'), $line->active ? 'switch_on' : 'switch_off');
                }
                print "</td>";

                print '<td align="center">';
                // Modify link
                if ($dictionary->lineCanBeUpdated && $canUpdate) print '<a class="reposition" href="' . dol_buildpath('/framework/admin/index.php',2) . '?page=dictionaries&' . $param . '&rowid=' . $line->id . '&action=edit' . '#rowid-' . $line->id . '">' . img_edit() . '</a>';
                // Delete link
                if ($dictionary->lineCanBeDeleted && $canDelete) print '<a href="' . dol_buildpath('/framework/admin/index.php',2) . '?page=dictionaries&' . $param . '&rowid=' . $line->id . '&prevrowid=' . $last_rowid . '&action=delete' . '&rowid=' . $line->id . '">' . img_delete() . '</a>';
                print '</td>';
                print "</tr>";
            }
            $last_rowid = $line->id;
        }

        $parameters = array();
        $reshook = $hookmanager->executeHooks('printFieldListFooter', $parameters, $dictionary, $action);
        print $hookmanager->resPrint;

        print '</table>';
        print '</div>';

        print '</form>';
    } else {
        setEventMessage($dictionary->errorsToString(), 'errors');
    }
} else {
    /*
     * Show list of dictionary to show
     */

    print '<div class="div-table-responsive-no-min">';
    print '<table class="noborder" width="100%">';
    print '<tr class="liste_titre">';
    print '<td width="10px">';
    print '<td width="20%">' . $langs->trans("Module") . '</td>';
    print '<td width="40%">' . $langs->trans("Dictionary") . '</td>';
    print '<td>' . $langs->trans("Table") . '</td>';
    print '</tr>';

    $dictionaries = Dictionary::fetchAllDictionaries($db, $module, $familyFilter);
// print_r($dictionaries); 

    $var = false;
    $lastfamily = '';
    foreach ($dictionaries as $dictionary) {
        $var = !$var;
        if ($dictionary->enabled) {
            $langs->loadLangs($dictionary->langs);

            if ($lastfamily != $dictionary->family) {
                $var = false;
                $lastfamily = $dictionary->family;
                print '<tr class="' . $bc[$var] . ' family_title"><td colspan="4">' . $langs->trans($dictionary->familyLabel) . '</td></tr>';
            }

            print '<tr class="' . $bc[$var] . '"><td width="10px"></td>' .
                '<td width="20%">' . (!empty($dictionary->modulePicto) ? img_picto('', $dictionary->modulePicto) . ' ' : '') . $langs->trans($dictionary->moduleLabel) . '</td>' .
                '<td width="40%"><a href="' . dol_buildpath('/framework/admin/index.php',2). '?page=dictionaries&module=' . $dictionary->module . '&name=' . $dictionary->name . '">' .
                $langs->trans($dictionary->nameLabel) . '</a></td>' .
                '<td>' . $dictionary->table_name . '</td></tr>';
        }
    }
    print '</table>';
    print '</div>';
}

print '<br>';